import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;




public class TestImage1 {

	public void createImage(String filename) 
	{
		
		 
		int w = 120;
		int h = 120;

		BufferedImage img = new BufferedImage(3*w, h,
                    BufferedImage.TYPE_INT_RGB);
		Graphics2D g2 = img.createGraphics();
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);
		// fill background
		Color bg = new Color(200,0,0);
		g2.setColor(bg);
		g2.fillRect(0,0,w,h);
		bg = new Color(0,200,0);
		g2.setColor(bg);
		g2.fillRect(w,0,w,h);
		bg = new Color(0,0,200);
		g2.setColor(bg);
		g2.fillRect(2*w,0,w,h);


		// write to file
		String format = "png";
		File file = new File(filename + "." + format);
		try {
			ImageIO.write(img, format, file);
		} catch (IOException e) {
			System.out.println("image write failed");
			//e.printStackTrace();
		}
	}



	public static void main(String[] args) {
		String name = "test";
		if (args.length>0) name = (args[0]);
		TestImage1 proj = new TestImage1();
		proj.createImage(name);
	}

}